#<pro4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire10three4xi.py">
#<abstract4xi abstract = "fires to direction three"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire10three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three104xi            # 10   - 90 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three104xi = {
                1:'0x0y-39z',
                2:'0x0y-69z',
                3:'0x19y-4z',
                4:'0x1y-69z',
                5:'0x2y-69z',
                6:'0x3y-69z',
                7:'0x4y-69z',
                8:'0x53y-26z',
                9:'0x7y-29z',
                10:'0x8y-39z',
                11:'0x9y-38z',
                12:'10x7y-58z',
                13:'11x44y-19z',
                14:'13x0y-58z',
                15:'13x44y-19z',
                16:'15x43y-19z',
                17:'18x42y-18z',
                18:'1x19y-4z',
                19:'1x44y-21z',
                20:'1x4y-69z',
                21:'1x5y-69z',
                22:'1x7y-28z',
                23:'1x8y-28z',
                24:'1x9y-2z',
                25:'20x41y-18z',
                26:'21x74y-45z',
                27:'22x40y-17z',
                28:'22x65y-40z',
                29:'23x29y-13z',
                30:'24x28y-12z',
                31:'24x39y-17z',
                32:'26x27y-12z',
                33:'26x64y-39z',
                34:'27x26y-11z',
                35:'27x38y-16z',
                36:'29x24y-11z',
                37:'29x63y-38z',
                38:'2x19y-4z',
                39:'2x5y-69z',
                40:'2x6y-69z',
                41:'2x8y-28z',
                42:'2x9y-1z',
                43:'2x9y-2z',
                44:'30x23y-11z',
                45:'31x21y-10z',
                46:'33x62y-37z',
                47:'36x60y-37z',
                48:'39x59y-36z',
                49:'3x45y-21z',
                50:'3x6y-59z',
                51:'3x6y-69z',
                52:'3x8y-28z',
                53:'3x9y-1z',
                54:'43x57y-35z',
                55:'46x55y-35z',
                56:'49x52y-34z',
                57:'4x5y-18z',
                58:'4x6y-59z',
                59:'4x8y-1z',
                60:'4x8y-28z',
                61:'4x9y-1z',
                62:'52x36y-27z',
                63:'52x50y-33z',
                64:'54x47y-32z',
                65:'57x45y-32z',
                66:'5x5y-18z',
                67:'5x7y-59z',
                68:'5x8y-1z',
                69:'5x8y-28z',
                70:'6x44y-20z',
                71:'6x4y-18z',
                72:'6x5y-18z',
                73:'6x7y-1z',
                74:'6x7y-59z',
                75:'6x8y-28z',
                76:'7x6y0z',
                77:'7x7y-59z',
                78:'7x7y0z',
                79:'8x0y-18z',
                80:'8x44y-20z',
                81:'8x5y0z',
                82:'8x7y-58z',
                83:'9x7y-58z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire10three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire10three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE2THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three104xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three104xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three8shot2three104xi</nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire10three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
               